CGO
Date: 2019-10-22

org.jmol.shapecgo

## Class CGO

- java.lang.Object
- - org.jmol.shape.Shape
  - - org.jmol.shape.MeshCollection
    - - org.jmol.shapecgo.CGO

-     public class CGO
      extends MeshCollection

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private CGOMesh` | `cgoMesh`
    `(package private) CGOMesh[]` | `cmeshes`
    `private int` | `indicatedModelIndex`
    `private float` | `newScale`
    `private boolean` | `useColix`

    - ### Fields inherited from class org.jmol.shape.MeshCollection

      `bsDisplay, colix, color, connections, currentMesh, displayWithinDistance2, displayWithinPoints, explicitID, htObjects, isDisplayWithinNot, isFixed, linkedMesh, meshCount, meshes, modelIndex, nUnnamed, pickedMesh, pickedModel, pickedPt, pickedVertex, PREVIOUS_MESH_ID, previousMeshID, title`

    - ### Fields inherited from class org.jmol.shape.Shape

      `bsColixSet, bsSizeSet, isBioShape, ms, myType, RADIUS_MAX, shapeID, translucentAllowed, translucentLevel, vf, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CGO()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `allocMesh(java.lang.String thisID, Mesh m)`
    `protected void` | `clean()`
    `private void` | `deleteMeshElement(int i)`
    `protected void` | `deleteModels(int modelIndex)`
    `private java.lang.String` | `getCommand(Mesh mesh)`
    `private java.lang.String` | `getCommand2(Mesh mesh, int modelCount)`
    `java.lang.Object` | `getProperty(java.lang.String property, int index)`
    `boolean` | `getPropertyData(java.lang.String property, java.lang.Object[] data)`
    `java.lang.Object` | `getShapeDetail()`
    `java.lang.String` | `getShapeState()`
    `private void` | `initCGO()`
    `private void` | `scale(Mesh mesh, float newScale)`
    `private boolean` | `setCGO(javajs.util.Lst<java.lang.Object> data)`
    `void` | `setModelVisibilityFlags(javajs.util.BS bsModels)`
    `void` | `setProperty(java.lang.String propertyName, java.lang.Object value, javajs.util.BS bs)`
    `private void` | `setPropertySuper(java.lang.String propertyName, java.lang.Object value, javajs.util.BS bs)`

    - ### Methods inherited from class org.jmol.shape.MeshCollection

      `checkExplicit, deleteMeshI, deleteMeshKey, getIndexFromName, getMesh, getMeshList, getPickedPoint, getPropDataMC, getPropMC, initShape, merge, resetObjects, setPropMC, setStatusPicked, setTokenProperty`

    - ### Methods inherited from class org.jmol.shape.Shape

      `appendCmd, checkBoundsMinMax, checkObjectClicked, checkObjectDragged, checkObjectHovered, coordinateInRange, encodeColor, findNearestAtomIndex, getColix, getColixA, getColixB, getColixI, getColorCommand, getColorCommandUnk, getFontCommand, getPropShape, getSize, getSizeG, getTranslucentLabel, initializeShape, initModelSet, replaceGroup, setAtomClickability, setModelSet, setPropS, setShapeSizeRD, setSize, setSizeRD, wasClicked`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### cmeshes

          CGOMesh[] cmeshes

    - #### cgoMesh

          private CGOMesh cgoMesh

    - #### useColix

          private boolean useColix

    - #### newScale

          private float newScale

    - #### indicatedModelIndex

          private int indicatedModelIndex

  - ### Constructor Detail

    - #### CGO

          public CGO()

  - ### Method Detail

    - #### initCGO

          private void initCGO()

    - #### allocMesh

          public void allocMesh(java.lang.String thisID,
                                Mesh m)

      Overrides:
        `allocMesh` in class `MeshCollection`

    - #### setProperty

          public void setProperty(java.lang.String propertyName,
                                  java.lang.Object value,
                                  javajs.util.BS bs)

      Specified by:
        `setProperty` in class `Shape`

    - #### deleteModels

          protected void deleteModels(int modelIndex)

    - #### getProperty

          public java.lang.Object getProperty(java.lang.String property,
                                              int index)

      Overrides:
        `getProperty` in class `Shape`
      Returns:
        true if serviced

    - #### getPropertyData

          public boolean getPropertyData(java.lang.String property,
                                         java.lang.Object[] data)

      Overrides:
        `getPropertyData` in class `Shape`
      Returns:
        true if serviced

    - #### deleteMeshElement

          private void deleteMeshElement(int i)

    - #### setPropertySuper

          private void setPropertySuper(java.lang.String propertyName,
                                        java.lang.Object value,
                                        javajs.util.BS bs)

    - #### clean

          protected void clean()

      Overrides:
        `clean` in class `MeshCollection`

    - #### setCGO

          private boolean setCGO(javajs.util.Lst<java.lang.Object> data)

    - #### scale

          private void scale(Mesh mesh,
                             float newScale)

    - #### getShapeDetail

          public java.lang.Object getShapeDetail()

      Overrides:
        `getShapeDetail` in class `Shape`

    - #### getShapeState

          public java.lang.String getShapeState()

      Specified by:
        `getShapeState` in class `Shape`

    - #### getCommand

          private java.lang.String getCommand(Mesh mesh)

    - #### getCommand2

          private java.lang.String getCommand2(Mesh mesh,
                                               int modelCount)

    - #### setModelVisibilityFlags

          public void setModelVisibilityFlags(javajs.util.BS bsModels)

      Overrides:
        `setModelVisibilityFlags` in class `MeshCollection`